<?php
/**
* @title   miniTEK FAQ Book
* @version   1.1
* @copyright   Copyright (C) 2011 Minitek, All rights reserved.
* @license   GNU General Public License version 2 or later.
* @author url   http://www.minitek.gr/
* @author email   info@minitek.gr
* @developer   Ioannis Maragos - minitek.gr
*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla modelitem library
jimport('joomla.application.component.modelitem');
 
/**
 * Category Model
 */
class FaqBookModelCategory extends JModelItem
{ 
	//var $_data = null;
	var $_subcategories = null;
	
	function __construct() {
	
		parent::__construct();
		
	}
	
	/**
	 * Method to get Subcategories
	 * @access public
	 * @return array
	 */
	function getSubCategories($id) {
   
		$db =& $this->getDBO();			

		$subwhere = $this->_buildSubwhere($id);	

		$query = "SELECT * FROM #__categories ". $subwhere ." ORDER BY rgt ";		
		
		$db->setQuery( $query );
		$subcategories = $db->loadObjectList();

		return $subcategories;		
	}
	
	/**
	 * Method to get Query Subwhere
	 * @access public
	 * @return array
	 */
	function _buildSubwhere($id) {
	
    $user	=& JFactory::getUser();
		$this_user = $user->id;
		
		$subwhere = array();
		
		if ($this_user==0) {
		$subwhere[] = 'access = 1';
		}
		
		$subwhere[] = "parent_id = ".$id;
		$subwhere[] = 'extension = "com_faqbook" ';
		$subwhere[] = 'published = 1';
				
		$subwhere 		= ( count( $subwhere ) ? ' WHERE ' . implode( ' AND ', $subwhere ) : '' );

		return $subwhere;	
	}
	
	/**
	 * Method to get Subcategory Items
	 * @access public
	 * @return array
	 */
	function getSubCategoryItems($id) {
   
		$db =& $this->getDBO();			

		$itemsubwhere = $this->_buildItemSubwhere($id);	

		$query = "SELECT * FROM #__faqbook_items ". $itemsubwhere ." ORDER BY ordering ";		
		
		$db->setQuery( $query );
		$faqs = $db->loadObjectList();

		return $faqs;		
	}
	
	/**
	 * Method to get Query ItemSubwhere
	 * @access public
	 * @return array
	 */
	function _buildItemSubwhere($id) {
	
    $user	=& JFactory::getUser();
		$this_user = $user->id;
		
		$itemsubwhere = array();
		
		if ($this_user==0) {
		$itemsubwhere[] = 'access = 0';
		}
		
		$itemsubwhere[] = "catid = ".$id;
		$itemsubwhere[] = 'published = 1';
				
		$itemsubwhere 		= ( count( $itemsubwhere ) ? ' WHERE ' . implode( ' AND ', $itemsubwhere ) : '' );

		return $itemsubwhere;	
	}
	
	/**
	 * Method to get Query Parent Category Name
	 * @access public
	 * @return array
	 */
	
	function getCategoryName($id) {
   
		$db =& $this->getDBO();			

		$query = "SELECT * FROM #__categories WHERE id=$id ";		
		
		$db->setQuery( $query );
		$categoryname = $db->loadObject();

		return $categoryname;		
	}
	
	/**
	 * Method to store Faq Rating
	 * @access public
	 * @return array
	 */
	function storeRating($id, $type) {
		$db = &JFactory::getDBO();
		$user = JFactory::getUser();

		if ($type == 1) {
			$query = 'update #__faqbook_items set votes_up = votes_up +1 where id=' . $id;
			$db->setQuery($query);
			$db->query();
    }
		if ($type == 0) {
		  $query = 'update #__faqbook_items set votes_down = votes_down +1 where id=' . $id;
			$db->setQuery($query);
			$db->query();
    }
			
	}
	
	/**
	 * Method to store New Faq
	 * @access public
	 * @return array
	 */
	function store()
	{
		$row =& $this->getTable();

		$data = JRequest::get( 'post' );

		// Bind the form fields to the table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Make sure the  record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $row->getErrorMsg() );
			return false;
		}

		return true;
	}
		
}